#include <stdlib.h>
#include <stdarg.h>

#ifndef _H_QuickSort
#include "_QuickSort.h"
#endif

/* void _QuickSort( int _numElements, Boolean _order, int _numArgs,
                    int TYPE1, Ptr *list1,
                    int TYPE2, Ptr *list2,
                      .    .     .     .
                      .    .     .     .
                      .    .     .     .       )
   where _numElements is the number of elements in list1 to be sorted
                      (i.e. 0<=i<_numElements)
         _order gives the order to sort in:  ASCENDING (TRUE) or
                                             DESCENDING (FALSE)
         _numArgs is the number of lists to follow (types and pointers)
         TYPE? is an int giving the type of the corresponding list? array.
               Currently, this can be INT, LONG, LONGINT,
               SHORT, SHORTINT, STR255 (Pascal string),
               CHARPTR (C string), CHAR (one character per array element),
               RESDATA.
         list? is an array of type TYPE?.
   
   This will sort according to the elements in list1, with the elements of
   list[2-?] fixed with it's corresponding element in list1.
   
   for example, a call might be:
   
       int    _numberOfElementsToSort;
       long   _socialSecurityNumber[100];
       Str255 _lastNames[100];
       Str255 _firstNames[100];
       int    _employeeNumber[100];
       long   _zipCode[100];
       
          .
          .
          .
       
       _QuickSort( _numberOfElementsToSort, ASCENDING, 5,
                   LONG,   (Ptr)_socialSecurityNumber,
                   STR255, (Ptr)_lastNames,
                   STR255, (Ptr)_firstNames,
                   INT,    (Ptr)_employeeNumber,
                   LONG,   (Ptr)_zipCode );
       
       This will sort a group of employees by (ascending) Social Security #.
                                                    */

struct resourceData { Handle  handle;
                      int     ID;
                      Str255  name;
                      Boolean useThisOne;
                     };
typedef struct resourceData ResourceData;
typedef ResourceData *ResourceDataPtr;
#define RESOURCEDATA_SIZE	sizeof(ResourceData)






_QuickSort( int _numElements, Boolean _ascending, int _numLists, ... )
  {va_list     _arguments;
   int         i, j, k, l, m, o, *_type, _answer, ii;
   Ptr         *_lists;
   int         _tempInt;
   long        _tempLong;
   short       _tempShort;
   char        _tempChar, *_tempStringPtr, *_cString1, *_cString2;
   Str255      _pString1, _pString2, _tempStr255;
   Boolean     _doSwap;
   ResourceData _tempResData;
    
    va_start( _arguments, _numLists );
    _lists = (Ptr *) NewPtr( _numLists * sizeof(Ptr) );
    _type = (int *) NewPtr( _numLists * sizeof(int) );
    for (i=0; i<_numLists; i++)
      { _type[i]  = va_arg( _arguments, int );
        _lists[i] = va_arg( _arguments, Ptr );
       }
    va_end( _arguments );
    
    m = _numElements / 2;
    while (m>=1)
      { k = _numElements - m;
        j = 1;
        do
          { i = j;
            do
              { l = i + m;
                switch (_type[0])
                  { case INT:
                         _doSwap = ((( ((int *)(_lists[0]))[i-1] >
                                       ((int *)(_lists[0]))[l-1] ) && _ascending)
                                || (( ((int *)(_lists[0]))[i-1] <
                                  ((int *)(_lists[0]))[l-1] ) && (!_ascending)));
                         break;
                    case LONG:
                    case LONGINT:
                         _doSwap = (( ( ((long *)(_lists[0]))[i-1] >
                                      ((long *)(_lists[0]))[l-1] ) && _ascending)
                                || (( ((long *)(_lists[0]))[i-1] <
                                 ((long *)(_lists[0]))[l-1] ) && (!_ascending)));
                         break;
                    case SHORT:
                    case SHORTINT:
                         _doSwap = (( ( ((short *)(_lists[0]))[i-1] >
                                     ((short *)(_lists[0]))[l-1] ) && _ascending)
                                || (( ((short *)(_lists[0]))[i-1] <
                                ((short *)(_lists[0]))[l-1] ) && (!_ascending)));
                         break;
                    case STR255:
                         _answer = IUCompString( ((Str255 *)(_lists[0]))[i-1],
                                                 ((Str255 *)(_lists[0]))[l-1]  );
                         _doSwap =  (   ( (_answer>0) && _ascending )
                                     || ( (_answer<0) && (!_ascending) )      );
                         break;
                    case CHARPTR:
                         _cString1 = ((char **)(_lists[0]))[i-1];
                         _cString2 = ((char **)(_lists[0]))[l-1];
                         ii = 0;
                         _answer = 0;
                         _pString1[0] = 1;
                         _pString2[0] = 1;
                         while ( (_cString1[ii]!='\0') && (_cString2[ii]!='\0')
                                                       && (_answer==0) )
                           { _pString1[1] = _cString1[ii];
                             _pString2[1] = _cString2[ii];
                             _answer = IUCompString( _pString1, _pString2 );
                            }
                         if (_answer==0)
                           { if (_cString1[ii]!='\0')
                                 _answer = 1;
                             else if (_cString2[ii]!='\0')
                                 _answer = -1;
                            }
                         _doSwap =  (   ( (_answer>0) && _ascending )
                                     || ( (_answer<0) && (!_ascending) )      );
                         break;
                    case CHAR:
                         _doSwap = (( ( ((char *)(_lists[0]))[i-1] >
                                      ((char *)(_lists[0]))[l-1] ) && _ascending)
                                || (( ((char *)(_lists[0]))[i-1] <
                                 ((char *)(_lists[0]))[l-1] ) && (!_ascending)));
                         break;
                    case RESDATA:
                         _doSwap = (( ( ((ResourceDataPtr)(_lists[0]))[i-1].ID >
                         ((ResourceDataPtr)(_lists[0]))[l-1].ID ) && _ascending)
                             || (( ((ResourceDataPtr)(_lists[0]))[i-1].ID <
                     ((ResourceDataPtr)(_lists[0]))[l-1].ID ) && (!_ascending)));
                         break;
                   }
                if (_doSwap)
                  { for (o=0; o<_numLists; o++)
                     switch (_type[o])
                     {case INT:
                       _tempInt                  = ((int *)(_lists[o]))[i-1];
                       ((int *)(_lists[o]))[i-1] = ((int *)(_lists[o]))[l-1];
                       ((int *)(_lists[o]))[l-1] = _tempInt;
                       break;
                      case LONG:
                      case LONGINT:
                       _tempLong                  = ((long *)(_lists[o]))[i-1];
                       ((long *)(_lists[o]))[i-1] = ((long *)(_lists[o]))[l-1];
                       ((long *)(_lists[o]))[l-1] = _tempLong;
                       break;
                      case SHORT:
                      case SHORTINT:
                       _tempShort                  = ((short *)(_lists[o]))[i-1];
                       ((short *)(_lists[o]))[i-1] = ((short *)(_lists[o]))[l-1];
                       ((short *)(_lists[o]))[l-1] = _tempShort;
                       break;
                      case STR255:
                       for (ii=0; ii<=((Str255*)(_lists[o]))[i-1][0]; ii++)
                           _tempStr255[ii] = ((Str255*)(_lists[o]))[i-1][ii];
                       for (ii=0; ii<=((Str255*)(_lists[o]))[l-1][0]; ii++)
                           ((Str255*)(_lists[o]))[i-1][ii] =
                                               ((Str255*)(_lists[o]))[l-1][ii];
                       for (ii=0; ii<=((Str255*)(_lists[o]))[l-1][0]; ii++)
                           ((Str255*)(_lists[o]))[l-1][ii] =
                                               _tempStr255[ii];
                       break;
                      case CHARPTR:
                       _tempStringPtr              = ((char **)(_lists[o]))[i-1];
                       ((char **)(_lists[o]))[i-1] = ((char **)(_lists[o]))[l-1];
                       ((char **)(_lists[o]))[l-1] = _tempStringPtr;
                       break;
                      case CHAR:
                       _tempChar                  = ((char *)(_lists[o]))[i-1];
                       ((char *)(_lists[o]))[i-1] = ((char *)(_lists[o]))[l-1];
                       ((char *)(_lists[o]))[l-1] = _tempChar;
                       break;
                      case RESDATA:
                       _tempResData = ((ResourceDataPtr)(_lists[0]))[i-1];
                       ((ResourceDataPtr)(_lists[0]))[i-1] =
                                     ((ResourceDataPtr)(_lists[0]))[l-1];
                       ((ResourceDataPtr)(_lists[0]))[l-1] = _tempResData;
                       break;
                      }
                    i -= m;
                   }
                else
                    break;
                }while (i>=1);
            j++;
           }while (j<=k);
        m /= 2;
       }
    DisposPtr( _lists );
   }






